= CHVote Threat model: Control components
:imagesdir: ../images
:title-logo-image: image:common/background.jpg[]
:media: print
v0.7, 2018-09-20

:toc:

== Modifications, controls, approval
[cols="15,15,40,30"]
|===
|Version |Date |Description, comments |Name or role

|0.1
|2018-02-29
|Initial revision.
|Christophe Vigouroux

|0.2
|2018-03-07
|Databases implemented into the CCs, no SAN involved for storing the data.
|Christophe Vigouroux

|0.3
|2018-03-22
|Include the SAN as an external dependency (finally, data are stored into the SAN),
add the phyiscal access controls, update architecture diagrams, integrate peer review
feedback.
|Christophe Vigouroux

|0.4
|2018-03-28
|Improve readability, integrate peer review feedback.
|Christophe Vigouroux

|0.5
|2018-08-13
a|- Update the physical access controls:

 * new concept for the CC administrators (4 independent teams forming 4 different pairs)
 * master code and master key threat analysis

 - Update the filesystem encryption:

 * The SAN volume is encrypted using a key stored locally on the CC. This key is not encrypted anymore. This was needed for a threat regarding the destruction of the disks by a third party, but it is now ensured by the CC admins by a written and traced process
 * The private signature key is now stored locally rather than on the SAN. The 2 nodes of a same CC do not share the same private signature key.
 * OS is stored locally too.
|Christophe Vigouroux

|0.6
|2018-09-04
a|- Update the CC disks destruction process
- Take into account feedback from Objectif Sécurité
|Christophe Vigouroux

|0.7
|2018-09-20
a|- Update countermeasure for T.14, the previous one was too permissive.
|Christophe Vigouroux

|===

== Introduction

=== Scope

The scope of this threat model is the control components of the CHVote
system.

=== Methodology

The document uses the OWASP application threat modeling method, please visit
https://www.owasp.org/index.php/Application_Threat_Modeling for more information.

=== Relation to the SSDLC

The goal is to cover the OpenSAMM Threat Assessment Level 1 maturity model,
visit https://www.owasp.org/index.php/SAMM_-_Threat_Assessment_-_1 for further details.

=== Analyzed system description

The control components are responsible of distributing
the cryptographic protocol of the CHVote system so that it is sufficient
that one of the control components behaves honestly to detect any
manipulation attempt on the server side, whether by an internal or an
external actor. In other words, compromising an election would require
the collaboration of all of the (independent) control components.
Technically, each control component is grouped into a cluster of at
least two instances sharing the same data (keys, state) for high
availability and load sharing purposes. Each cluster is implemented
using different operating systems so that to comply to the federal
requirements with the goal to minimize the risk of having a single
vulnerability affecting all the control components systems.


=== Architecture overview
The following diagrams show the overview of the architecture of the online CHVote system, then
of the offline CHVote applications.

The analyzed components are only a subset of the entire architecture. They can be found at the
bottom of the first diagram (see the CHVote Control components networks lane).

<<<
image::architecture-overview-online-system.png[Architecture overview of the online system,pdfwidth=100%]

<<<
image::architecture-overview-offline-tools.png[Architecture overview of the offline tools,pdfwidth=100%]

<<<
== External dependencies

[width="100%",cols="4%,96%",options="header",]
|=======================================================================
|ID |Description
|1 |Server: the control component application is running on a dedicated
bare-metal server. The underlying operating system is kept up-to-date
and configured and managed according to CIS level 2 best practices (Center
for Internet Security). No remote access is provided on this server, only
local console access. No access is required before, during and after an
election. Access to local console is possible for an operator together
with a system administrator for applying patches or solving component
failures. The same pair cannot access multiple control components.

|2 |Message broker: the message broker enables the loose communication
between the control components and the other parts of the CHVote system
(bulletin board, platform administration, vote receiver). The service
will only be available through a secure protocol (TLS) with a valid TLS
certificate.

|3 |Logs centralization: the logs centralization application receives
all the logs of the CHVote applications, including those of the control
components applications, for the needs of the system operation: incident
handling and security analysis. No sensitive data is stored in these logs.
The service will only be available through a secure protocol (TLS) with
a valid TLS certificate.

|4 |System monitoring: the system monitoring application receives system
metrics and alerts from the control component. It enables the IT operations
to be informed of system incidents. The service will only be available through
an encrypted nagios protocol (NRDP).

|5 |The health metrics service is guarded by a firewall that discards
packets not originating from the legitimate subnets of the operations
health monitors.

|6 |Certificate validation: the setup of the control components
guarantees that they hold the correct certificates required to
authenticate communication partners and verify signatures. The control
components use these certificates explicitly without relying on a
certification authority.

|7 |Physical access controls: the control components are installed into
racks that are secured with a physical access control, consisting of mechanical
doors closed by two locks. Each control component is secure behind its own
door and two locks. Thus, in one datacenter, there are 8 keys matching the
8 control component locks, that are secured in 8 safes, each one protected
by its own PIN code. The same matching locks are used on the other datacenter,
so that each key has a backup in the other datacenter.

|8 |Storage Area Network (SAN): the database data is stored on a volume
encrypted by the control component, that is mapped to a LUN on a shared SAN.
The control components communicate with the SAN using a standard protocol,
SCSI over FibreChannel. The volume encryption key is provided in a file stored
locally on the control component, see asset 2.3 Control component filesystem
encryption key.

|9 |Inter datacenter network: the control components nodes are placed into two
distinct datacenters to ensure high availability and continuity of activity.
The nodes lie in the same VLAN, consisting of redundant switches and two redundant
optical fiber links common to the four control components. Traffic between the
control components nodes is always encrypted by TLS and the SQL clients verify
the TLS certificates before connecting.

|=======================================================================

<<<
== Entry points

[width="100%",cols="4%,18%,58%,20%",options="header",]
|=======================================================================
|ID |Name |Description |Trust levels
|1 |HTTPS port |The control components expose health metrics using
Spring Actuator (REST services). |(5) Operator

|1.1 |Health metrics service |The health metrics service accepts REST
requests and issues corresponding answers |(5) Operator

|2 |Message broker |Protocol messages are exchanged asynchronously
through the message broker (AMQP), using an underlying secured protocol
(TLS) |(3) Message broker read/write user

|=======================================================================

== Trusts levels

[width="100%",cols="4%,30%,66%",options="header",]
|=======================================================================
|ID |Name |Description
|1 |Anonymous user |A user who has connected to the system but has not
provided valid credentials.

|2 |Control component application user |This is the user the control
components executes codes as.

|3 |Message broker read/write user |The message broker account used to
exchange messages with the other services of the voting platform.

|4 |Database read/write user |The database user account used to access
the database for read and write access. Database user credentials are
different for each control component.

|5 |Operator |The operators have access to the health metrics of the
control components and receive logs and nagios passive system checks.

|6 |Control component administrators |Two system or database administrators
that have controlled access to the local console of a control component.
|=======================================================================

<<<
== Assets

[width="100%",cols="9%,27%,41%,23%",options="header",]
|=======================================================================
|ID |Name |Description |Trust levels
|*1*
3+|*Election data*

|1.1 |Event log a|Log of all the events representing the state of the
control component. The following assets are the different types of
events stored by the event log.

NOTE: The event log is stored in the database,
and not as a log file. It is therefore not included in the application log
centralization as mentioned in the external dependencies. |(2) Control
component application user

|1.1.1 |Public parameters |The public parameters published by the CHVote
platform are stored into the control component event log. |(2) Control
component application user

|1.1.2 |Protocol instance key pair |An ElGamal key pair is generated by
each control component when the protocol is initialized. The public key
parts of each control components are published to the bulletin board and
merged with the election officer public key part to create the ballots
encryption public key. The private key is used for partially decrypting
the ballots. |(2) Control component application user

|1.1.3 |Election officer public key |The public key of the election
officer published by the CHVote platform is stored into the control
component event log. |(2) Control component application user

|1.1.4 |Control components public keys |The protocol public keys of all
the control components (including self) are stored into the control
component event log. |(2) Control component application user

|1.1.5 |System public key |The result of the merge of the election
officer public key and the control components public keys is stored into
the control component event log as the system public key. |(2) Control
component application user

|1.1.6 |Election set |The election set is stored into the control
component event log. It contains the protocol representation of the
voters, candidates, elections, and public certificates of the printing
authorities. |(2) Control component application user

|1.1.6.1 |Voters |Basic voters information is stored into the control
component event log. They consist of a voter id (internal id, not the
voting card number), an eligibility vector, and the counting circle.
This is a local copy of the data already published to the bulletin
board. |(2) Control component application user

|1.1.6.2 |Candidates |The possible choices for an election are named
candidates. They are stored into the control component event log. This
is a local copy of the data already published to the bulletin board.
|(2) Control component application user

|1.1.6.3 |Elections |The elections supported by the current protocol
instance. They are stored into the control component event log. This is
a local copy of the data already published to the bulletin board. |(2)
Control component application user

|1.1.6.4 |Public certificates of the printing authorities |Printing
authorities publish their public key used by the control components to
encrypt the private credentials in the form of a certificate signed by
an certificate authority meeting the federal requirements (e.g.
Swisscom, SwissSign or QuoVadis) |(2) Control component application user

|1.1.7 |Electorate data |The election set is stored into the control
component event log. It contains the secret values of the code sheets.
|(2) Control component application user

|1.1.8 |Public credentials |The public credentials of all the control
components (including self) are stored into the control component event
log. |(2) Control component application user

|1.1.9 |Encrypted ballots |The encrypted ballots submitted by the voting
clients are stored into the control component event log. |(2) Control
component application user

|1.1.10 |Vote confirmations |The vote confirmations submitted by the
voting clients are stored into the control component event log. |(2)
Control component application user

|1.1.11 |Shuffles and proofs |Shuffles ans proofs of shuffles (mixnet
algorithm results) are stored into the control component event log. |(2)
Control component application user

|*2*
3+|*Cryptographic assets*

|2.1 |Control component signature private key |Key for signing the published
messages. It is stored locally on the control component disk array.|(2)
Control component application user, (6) Control component administrators

|2.2 |Control component signing public keys |Certificates for verifying
the signature of the messages published by the other control components.
They are stored locally on the control component disk array.|(2)
Control component application user, (6) Control component administrators

|2.3 |Control component filesystem encryption key |The key used to mount
the encrypted SAN volume of a control component. It is stored
locally on the control component disk array. |(6) Control component
administrators

|*3*
3+|*IT assets*

|3.1 |Control component application file |The file representing the
compiled application (Spring Boot jar file). |(2) Control component
application user

|3.2 |Log files |The application log files containing runtime events for
operations teams: application errors or warnings, security checks
results. Great care must be taken to not include sensitive data in those
logs as their are forwarded outside of the control component. |(2) Control
component application user

|3.3 |Message broker credentials |Login and password to connect to the
message broker. |(2) Control component application user

|3.4 |Message broker TLS public certificate |Public certificate of the
message broker endpoint to verify the authenticity of the server. |(2)
Control component application user

|3.5 |Control component TLS certificates |Public and private
certificates of the control component for connecting to the message
broker. |(2) Control component application user

|3.6 |Database credentials |Login and password to connect to the local
database. |(2) Control component application user

|3.7 |Environment variables |Environment variables set to define the
location of the message broker, of the database, etc. |(2) Control
component application user

|3.8 |Operating system hardened configuration |The overall configuration
of the operating system is audited and certified and it must not be changed
thereafter. | (6) Control component administrators

|*4*
3+|*Access and abilities assets*

|4.1 |Availability of the control components |The control components
should be available at all time during a voting period (from the
initialization phase up to the ballot box decryption phase). |

|4.2 |Ability to access the underlying operating system and run commands
|This is the ability to execute commands as a user or administrator of
the operating system and read/write files |(6) Control component
administrators

|4.3 |Ability to execute code as a control component user |This is the
ability to execute the Java application code on the control component.
|(2) Control component application user

|4.4 |Ability to execute SQL as a Database Read/Write User |This is the
ability to execute SQL select, insert, and update queries on the
database and thus have read and write access to any information stored
within the control component database. |(4) Database read/write user

|4.5 |Ability to receive or send messages |This is the ability to create
queues and exchanges, to bind queues to exchanges, to receive messages
from a queue or to publish messages into an exchange. |(3) Message
broker read/write user

|4.6 |Ability to gain physical access to a control component| This is the
ability to open the 2 locks of the door protecting a control component. This
includes the ability to open the safes containing the mechanical keys to open
the locks. |(6) Control component administrators

|=======================================================================

<<<
== Data flow diagram

image:dfd_control_components.png[Control components DFD]

<<<
== Threats

Threats are identified according to the STRIDE categorization model:

 * Spoofing: Threat action aimed to successfully misrepresent itself in a
way that fools a target into interacting with it as the misrepresented
system.

 * Tampering: Threat action aimed to maliciously change/modify
persistent data, such as persistent data in a database, and the
alteration of data in transit between two computers over an open
network, such as the Internet.

 * Repudiation: Threat action aimed to
perform illegal operations in a system that lacks the ability to trace
the prohibited operations.

 * Information Disclosure: Threat action to
read data that one was not granted access to, or to read data in
transit.

 * Denial of Service: Threat aimed to deny access to valid
users, such as by making a web server temporarily unavailable or
unusable.

 * Elevation of Privilege: Threat aimed to gain privileged
access to resources for gaining unauthorized access to information or to
compromise a system.

=== Spoofing Threats

==== S.1| Spoof health metrics client

Attacker may be able to make requests to health metrics
service from subnets allowed in the firewall, appearing as a valid
client.

===== Vulnerability
Sensitive data is retrieved from the health metrics service.

====== Countermeasures
* Authentication with a username and a strong password
is required before being allowed to query the service.
* An anti-bruteforce attack is implemented by the
health metrics service to avoid the attacker being able to guess the
credentials.
* Only access through TLS connections is allowed to the
health metrics service to prevent sniffing.

==== S.2| Spoof message broker
Attacker may be able to instantiate a malicious message broker that would act as a man in the middle.

===== Vulnerability
The message broker is not authenticated by the component interacting with it.

====== Countermeasures
* The control component checks the TLS certificate
presented by the message broker service, thus preventing a man in the
middle as long as the certificate is kept secured.
* The certificate used by the message broker is pinned
in the control component to prevent abuse of certificates by the CA
administrator.

==== S.3| Spoof messages
Attacker may be able to insert a spoofed message in the message broker.

===== Vulnerability
Control component produces incorrect results.

====== Countermeasures
* Integrity of the messages coming from the message
broker is checked by the control component using their signature before
interpreting them.

==== S.4| Spoof logs centralization service
Attacker may be able to instantiate a malicious logs
centralization service that would act as a man in the middle.

===== Vulnerability
The logs centralization service is not authenticated by
the component interacting with it.

====== Countermeasures
* The control component checks the TLS certificate
presented by the logs centralization service, thus preventing a man in the
middle as long as the certificate is kept secured.
* The certificate used by the logs centralization service
is pinned in the control component to prevent abuse of certificates by the
CA administrator.

==== S.5| Spoof monitoring server
Attacker may be able to instantiate a malicious system
monitoring server that would act as a man in the middle.

===== Vulnerability
The system monitoring service is not authenticated by
the component interacting with it.

====== Countermeasures:
* The control component checks the TLS certificate
presented by the system monitoring service, thus preventing a man in the
middle as long as the certificate is kept secured.
* The certificate used by the system monitoring service
is pinned in the control component to prevent abuse of certificates by the
CA administrator.

=== Tampering Threats

==== T.1| Tamper health metrics data
Attacker may be able to tamper data exchanged between the
monitoring tools and the health metrics service in transit.

===== Vulnerability
Health metrics data is modified to perform malicious
actions (e.g. hide alarms).

====== Countermeasure
* Only access through TLS connections is allowed to the
health metrics service to prevent sniffing and tampering.

===== Vulnerability
Answers to requests performed by the health metrics
service are dropped to hide alarms.

====== Countermeasures:
* Only access through TLS connections is allowed to
prevent Man-in-the-Middle attacks.
* An alarm is raised by the health metrics service if
no response is received for a query.

==== T.2| Tamper with incoming messages
Attacker may be able to intercept messages sent by the
message broker to the control component and modify their content.

===== Vulnerability
A malicious message broker declares itself instead of
the legitimate message broker and acts as a man in the middle.

====== Countermeasure
* same as S.2

==== T.3| Tamper with outgoing messages
Attacker may be able to intercept messages published by
the control components and modify their content.

===== Vulnerability
A malicious message broker declares itself instead of
the legitimate message broker and acts as a man in the middle.

====== Countermeasures
* Same as S.2
* The recipient of the message (bulletin board, vote
receiver or platform administration) performs the same countermeasures
as above.

==== T.4| Tamper with messages in the message broker
Attacker may be able to tamper messages intended for the
control component in the message broker.

===== Vulnerability
Same as S.3

====== Countermeasures
* Same as S.3

==== T.5| Delete vote confirmation from the database
Attacker may be able to delete a vote confirmation from
the control component database.

===== Vulnerability
Vote confirmation events identified as being linked
among the different control components can be removed without being
detected.

====== Countermeasures:
* Databases are implemented independently within each
control component. Deleting a vote confirmation would need to have a
physical access to the four control components.

==== T.6| Add vote to the database
Attacker may be able to add a vote to the control component database.

===== Vulnerability
A vote event is added to the four control component databases.

====== Countermeasures:
* Attacker should add vote to databases of all control
components to avoid being detected, but databases are implemented
independently within each control component, thus requiring physical
access to the four control components to perform a successful attack.

==== T.7| Modify the application code
Attacker may be able to modify the control component
application code on the the control component to perform various attacks
that could change the ballot outcome: discard of arbitrary or chosen
ballots, addition of ballots.

===== Vulnerability
The application code can be modified by an insider by
replacing application binaries or jvm binaries, or modified with a jvm
agent, without being detected.

====== Countermeasures
* The protocol is distributed in such a way that all
the control components must have been compromised with the rogue
application in order to avoid detection.
* Access to the control component system is restricted
to physical access only, granted only to (6) Control component
administrators).
* Two combined countermeasures: official code is
reviewed, audited and signed, and checked on deployment + attacker code
would need to be deployed separately to each CC, this would requires an
access to all the CCs.

===== Vulnerability
The application code can be modified by an external
attacker using a system vulnerability to gain privileged access on the
control component and by replacing application binaries or jvm binaries,
or modified with a jvm agent, without being detected.

====== Countermeasures
* The protocol is distributed in such a way that all
the control components must have been compromised with the rogue
application in order to avoid detection.
* The control components use different operating systems.
* The control components only expose the AMQP and
HTTPS ports required by the application, thus drastically decreasing the
remote attack surface.
* The control components services exposing the AMQP
and HTTPS ports use a proper validation strategy (WAF with whitelisting
and/or json conversion checks).

===== Vulnerability
A developer (internal developer or external
contributor) writes some malicious code into the control component
application that gets deployed to all the control components.

====== Countermeasures
* Every code change is peer reviewed before being
accepted into the master branch.
* The control component code is audited by a
third-party (security experts). The code is then compiled by this
auditor into the final application (jar artifact). The artifact is then
signed by the auditor. When the artifact is deployed onto the control
components, the auditor signature is verified by (3) Operator + control
component administrator.

===== Vulnerability
A code auditor writes some malicious code into the
control component application that gets deployed to all the control
components.

====== Countermeasures
* The artifact signed by the auditor is compared to
another compilation of the application made by the development team. If
the code base is not the same between the two different compilations
(auditor and development team), then the comparison would fail. If the
comparison succeeds, the development team also signs the artifact
provided by the auditor. When the artifact is deployed onto the control
components, the development team signature is also verified by (3)
Operator + control component administrator.

==== T.8| Alter the cryptographic assets
Attacker may be able to alter the cryptographic assets:
(2.1) Control component signature private key and (2.2) Control component signature public keys

===== Vulnerability
Insufficient protection of the asset.

====== Countermeasures
* The private key and the public keys are stored locally on the control component disk
array, thus requiring to have access to the two keys to open the control component door (see
<<E.1>>).
* The private key is never copied in clear text outside of the control component (no USB key
involved, no network connection used).
* The access to the control component are only possible using a local console.
* The control components use different operating systems.

==== T.9| Tamper with outgoing logs
Attacker may be able to tamper data exchanged between the
control component and the logs centralization service in transit.

===== Vulnerability
Logs are tampered to hide malicious actions.

====== Countermeasures:
* Only access through TLS connections is allowed to the
logs centralization service to prevent sniffing and tampering.

===== Vulnerability
Logs sent by the control component are dropped to hide
malicious actions.

====== Countermeasures:
* Only access through TLS connections is allowed to prevent Man-in-the-Middle
attacks.
* An alarm is raised if no log is received by the logs centralization service
after a predefined duration.

==== T.10| Tamper with outgoing monitoring data
Attacker may be able to tamper data exchanged between the
control component and the system monitoring service in transit.

===== Vulnerability
Monitoring values are modified to hide malicious actions.

====== Countermeasures:
* Only access through TLS connections is allowed to the
system monitoring service to prevent sniffing and tampering.

===== Vulnerability
Monitoring events sent by the control component are
dropped to hide malicious actions.

====== Countermeasures:
* Only access through TLS connections is allowed to prevent Man-in-the-Middle
attacks.
* An alarm is raised if no event is received by the system monitoring service
after a predefined duration.

==== T.11| Delete a vote using the SAN
Attacker may be able to delete a vote from the SAN.

===== Vulnerability
Vote events identified as being linked
among the different control components can be removed without being
detected directly by modifying blocks of data on the SAN.

====== Countermeasures
* All the control component data is encrypted by the control
component itself before being stored on the SAN. Removing a chosen data set
is impossible due to the non malleability of the encryption.
* Deleting a vote would require to know the encryption keys of the
4 control components.

==== T.12| Add a vote using the SAN
Attacker may be able to add a vote from the SAN.

===== Vulnerability:
A vote event is added by modifying blocks of data on the SAN.

====== Countermeasures:
* All the control component data is encrypted by the control
component itself before being stored on the SAN.
* Adding valid data would require to know the encryption
keys of the 4 control components.

==== T.13| Modify a vote using the SAN
Attacker may be able to modify a vote from the SAN.

===== Vulnerability
A vote event is modified by modifying blocks of data on the SAN.

====== Countermeasures:
* All the control component data is encrypted by the control
component itself before being stored on the SAN.
* Validly modifying data would require to know the
encryption keys of the 4 control components.

==== T.14| Drop the last votes from the SAN
Attacker may be able to drop the last vote confirmations from the SAN.

===== Vulnerability
The last vote confirmation events are dropped by
restoring a snapshot of each control component LUN.

====== Countermeasures
* Every control component runs a probe every 5 minutes that queries the number
of vote confirmations present in the database, stores the result on its local
volume, and compares the current value with the previous one. The probe must
raise an alert to the nagios system if the current value is lower than the previous value.

==== T.15| Modify the OS configuration
Attacker may be able to change the configuration of the operating
system of the control component.

===== Vulnerability
The operating system configuration is not protected from tampering.

====== Countermeasures
* The operating system is stored on the local SCSI array, so changing
the configuration is only restricted to the authorized control component administrators.
Indeed, access to the control component requires to have access to the two keys to open
the control component door (see <<E.1>>).

=== Repudiation Threats

==== R.1| Send a rogue message through the message broker
Attacker may be able to insert a rogue message in the
message broker stating it comes from a control component.

===== Vulnerability
Invalid data are published to the bulletin board

====== Countermeasures
* Integrity of the messages coming from the message
broker are checked by the bulletin board and the other vote components.

==== R.2| Send a rogue message through the bulletin board
Attacker may be able to insert a rogue message intended
for a control component in the message broker.

===== Vulnerability
Control components produces incorrect results.

====== Countermeasures
* Same as S.3.

=== Information Disclosure Threats

==== I.1| Intercept control component messages
Attacker may be able to intercept messages published by
the control components to the voting platform to gain knowledge of
valuable information (anticipated results, voter credentials, vote
contents)

===== Vulnerability
A malicious message broker declares itself instead of
the legitimate message broker and acts as a man in the middle.

====== Countermeasures
* Same as S.2.
* Ballots, resp. voter credentials, cannot be decrypted
without the knowledge of the election authority private key, resp. the
printer private key, that are never transmitted to the CHVote system.

==== I.2| Modify the application code to get votes
Attacker may be able to modify the control component
application code in order to decrypt ballots without being detected so
that a vote is revealed or anticipated results can be computed.

===== Vulnerability
All the control components collaborate with the
bulletin board to provide a fake encryption public key to the voting
client.

====== Countermeasures
* Same as T.7.

==== I.3| Get sensitive data from health metrics
Attacker may be able to make requests to health metrics
service from subnets allowed in the firewall, appearing as a valid
client.

===== Vulnerability
Sensitive data is retrieved from the health metrics service.

====== Countermeasures
* Same as S.1.

==== I.4| Store ballots for future decryption
An attacker may get a copy of the encrypted ballots, store them
and decrypt them in some future where nowadays cryptography can be easily defeated
to gain knowledge of each voter votes.

===== Vulnerability
Network listening devices are plugged between the voter and the
control components, or between the master and the slave database, and store the
encrypted data until such a time where the encryption used is insufficient to protect
the vote secrecy, and therefore break the confidentiality of the vote.

====== Countermeasures
* Only strong encryption keys are used (256 bits symmetric keys,
2048 bits asymmetric keys), with Perfect Forward Secrecy ciphers only (typically ECDHE).
* Two layers of encryption are used: TLS for communication, and
ElGamal at the protocol level, thus limiting the risk that one of those two layers
algorithms can be broken soon, leaving the risk of quantum computing being able to
defeat nowadays cryptography.

===== Vulnerability
The disk failure maintenance process is insufficiently secured and
disks can be repaired to restore and retrieve the encrypted ballots.

====== Countermeasures
* The disks are immediately and physically destructed upon replacement by
the Control components administrators.

===== Vulnerability
The database backup process is insufficiently secured and backups
can be found years later, allowing to decrypt all the data including the ballots.

====== Countermeasures
* The backups are only made locally to the SAN using
a snapshot method, nothing comes out of the SAN without being physically destructed.
The SAN cannot contain years of historical data because of the immense storage capacity
this would need. In fact, only a few weeks of snapshots can be preserved as a backup
policy.
* Administrative access to the SAN is made with a 4-eyes principle
and all actions are traced.
* Two layers of encryption are used: AES in counter mode for the
filesystem, and ElGamal at the protocol level, thus limiting the risk that one of those
two layers algorithms can be broken soon, leaving the risk of quantum computing being able to
defeat nowadays cryptography.

==== I.5| Retrieve the cryptographic assets
Attacker may be able to retrieve the cryptographic assets:
(2.1) control component signature private key

===== Vulnerability
Insufficient protection of the asset.

====== Countermeasures
* Same as T.8.

===== Vulnerability
The disk failure maintenance process is insufficient and
disks can be repaired to restore and retrieve the cryptographic assets.

====== Countermeasures
* When replacing a failed disk of the array, the disk is stored in the rack space of the control component.
The serial numbers of the failed disks are kept listed on two distinct papers by the two distinct administrators,
and each list is stored in the distinct administrators' safes.
* When renewing the complete server, the failed disks stored in the rack space are physically destructed using
a mechanical shredding service which needs to be rented when needed. This process is preferred to the one requiring
to buy an expensive machine to shred the disks at any time.

=== Denial of Service Threats

==== D.1| Flood health metrics
Attacker floods the control components with requests to
the health metrics (Spring actuator) REST endpoint. CPU usage is bloated
or responses to legitimate health check requests is precluded.

===== Vulnerability
The REST endpoint is accessible to an attacker.

====== Countermeasures
* The control component lies in a subnet that is
guarded by a firewall that discards packets not originating from the
legitimate subnets of the operations health monitors.

==== D.2| Flood message broker
Attacker floods the control components by publishing
messages to a queue consumed by the control component. CPU usage is
bloated or consumption of legitimate messages is precluded.

===== Vulnerability
The AMQP server is accessible to an attacker.

====== Countermeasures
* The AMQP server accepts connexion only from clients
presenting a valid certificate and valid credentials.
* The control component and the message broker lie in
subnets that are guarded by a firewall that discards packets not
originating from the legitimate subnets.

==== D.3| Place the control components in a discrepancy state
Attacker tampers with a control component event log or
carries out a repudiation attack in order to place the control component
in a discrepancy state relatively to the other control components. This
will ultimately result to a verification error at mixing time, thus
canceling the overall ballot.

===== Vulnerability
Vulnerabilities to tampering: same as T.5 and T.6.

====== Countermeasures
* Same as T.5 and T.6.

===== Vulnerability
Vulnerabilities to repudiation: same as R.1 and R.2.

====== Countermeasures
* Same as R.1 and R.2.

==== D.4| Tamper with data in the SAN
Attacker tampers with the control components LUNs in the SAN
in order to place the control component in a discrepancy state relatively to the
other control components. This will ultimately result to a verification error at
mixing time, thus canceling the overall ballot.

===== Vulnerability
The SAN administrator can delete the LUN, or restore on old snapshot.

====== Countermeasures
* Same as T.14, so that to receive an alert as soon as the attack is
conducted, rather than to wait for the verification error.
* Administrative access to the SAN is made with a 4-eyes principle
and all actions are traced.

=== Elevation of Privilege

==== [[E.1]]E.1| Abuse the physical access control
An attacker may abuse the physical access control to gain physical access
to the control components.

===== Vulnerability
A single person would be able to change or add access
grants to all the control component physical protections.

====== Countermeasures
* Access to each control component is granted using two mechanical
locks and their matching two keys provided by two independent Control component
administrators. Every control component has its own key set.

===== Vulnerability
A single person could get access to the two keys locking the physical
access to a control component.

====== Countermeasures
* The two keys are held within two safes each one protected by a different
PIN code. Each PIN code is only known by one of the two Control component administrators,
so a lone attacker cannot get the two PIN codes.

===== Vulnerability
The administrators of a control component could get access to the
other control components.

====== Countermeasures
* Each control component is assigned a different pair of administrators. The administrators
are split into 4 independent teams. Each team only knows the PIN codes necessary to get the
mechanical keys of the control components under their charge. +
As a result, it would need 4 different people to gain physical access to the 4 control
components.

.Administrators team distribution over the CCs
|===
|CC | Key 1 | Key 2

| CC 1 | Team 1 | Team 3
| CC 2 | Team 2 | Team 1
| CC 3 | Team 2 | Team 3
| CC 4 | Team 2 | Team 4

|===

===== Vulnerability
An attacker may brute force the PIN code of a safe.

====== Countermeasures
* Each individual safe is protected by a PIN code of 6 digits.
* The safe locks itself after 3 PIN code errors.
* The access to the safes is recorded on video.

===== Vulnerability
An attacker may abuse the emergency systems of the locker (master code and master key)
that are able to open all the safes in case of emergency (lost PIN code, locked safe,
battery renewal..).

====== Countermeasures
* The master code is constituted of a PIN code of 6 digits, logically separated into
3 parts of 2 digits. Each part is held by an election officer, who is not authorized to
access the datacenter by himself. In order to apply an emergency plan (PIN recovery or battery change),
the 3 election officers are accompanied by a pair of control component administrators to gain
access to the datacenter and to the locker located in it.
* The master mechanical key of a datacenter locker is placed into a safe of the other datacenter locker.
This specific safe is secured by 2 PIN codes of 6 digits, logically separated into
4 parts of 3 digits, each part owned by a distinct control component administration team.

==== E.2| Use a software vulnerability
An attacker may abuse a vulnerability in the software of
the entry points to execute code in the control component application
user trust level.

===== Vulnerability
The health metric software is vulnerable to specially crafted messages.

====== Countermeasures
* The message format is simple and is validated (JSON)
by a web application firewall (mod security for example) using a
whitelist of accepted requests.

===== Vulnerability
The message broker software is vulnerable to specially crafted messages.

====== Countermeasures
* The message format is simple and is validated (JSON,
deserialized objects using jackson library) by a content validation
service using a regular expression whitelist of the expected contents.
* The message broker is running an open-source software
making it difficult to hide a backdoor.

===== Vulnerability
The log forwarder software is vulnerable to specially crafted return messages.

====== Countermeasures
* The log forwarder software is simple and its code is
open-sourced, making it possible to verify that it behaves as expected.

===== Vulnerability
The nagios passive check agent software is vulnerable to specially crafted return
messages.

====== Countermeasures
* The passive check agent software is simple and its code is
open-sourced, making it possible to verify that it behaves as expected.

===== Vulnerability
The HBA card (Host Bus Adapter, used to connect to the SAN via
FibreChannel) driver is vulnerable to specially crafted messages.

====== Countermeasures
* 3 control components use 3 different providers of HBA cards however using a common
chip within. They come with 3 different drivers, with the limitation that they embed
a common driver for the common chip.
* 1 control component uses a second provider of HBA cards with a completely different
chipset and driver.

<<<
== Risk ranking of threats

=== Risk calculation

[width="100%",cols="40%,^12%,^12%,^12%,^12%,^12%",options="header",]
|=======================================================================
|Likelihood / Impact |0.5 +
Very unlikely |1 +
Unlikely |2 +
Probable |3 +
Highly probable |4 +
Almost certain
|4 +
Authorities credibility highly threatened |2 +
Low |4 +
Moderate |8 +
High
|12 +
High |16 +
High

|3 +
Authorities credibility moderately threatened |1.5 +
Low |3 +
Low |6 +
Moderate |9 +
High |12 +
High

|2 +
A ballot may not be completed |1 +
Low |2 +
Low |4 +
Moderate |6 +
Moderate
|8 +
High

|1 +
The VE is hardly questioned |0.5 +
Very low |1 +
Low |2 +
Low |3 +
Low |4 +
Moderate
|=======================================================================

=== Risk assessment matrix

[cols="5,56,^13,^13,13",options="header",]
|===============================================
|ID|Threat |Likelihood +
(0.5 - 4) |Impact +
(1 - 4) |Risk
|S.1| Spoof health metrics client |1 |1 |1 Low
|S.2| Spoof message broker |1 |2 |2 Low
|S.3| Spoof messages |1 |2 |2 Low
|S.4| Spoof logs centralization service |1 |1 |1 Low
|S.5| Spoof monitoring server |1 |1 |1 Low
|T.1| Tamper health metrics data |1 |2 |2 Low
|T.2| Tamper with incoming messages |1 |2 |2 Low
|T.3| Tamper with outgoing messages |1 |2 |2 Low
|T.4| Tamper with messages in the message broker |1 |2 |2 Low
|T.5| Delete vote confirmation from the database |0.5 |4 |2 Low
|T.6| Add vote to the database |0.5 |4 |2 Low
|T.7| Modify the application code |1 |4 |4 Moderate
|T.8| Alter the cryptographic assets |0.5 |4 |2 Low
|T.9| Tamper with outgoing logs |1 |2 |2 Low
|T.10| Tamper with outgoing monitoring data|1 |1 |1 Low
|T.11| Delete a vote using the SAN|0.5 |4 |2 Low
|T.12| Add a vote using the SAN|0.5 |4 |2 Low
|T.13| Modify a vote using the SAN|0.5 |4 |2 Low
|T.14| Drop the last votes from the SAN|0.5 |4 |2 Low
|T.15| Modify the OS configuration|0.5 |4 |2 Low
|R.1| Send a rogue message through the message broker |1 |2 |2 Low
|R.2| Send a rogue message through the bulletin board |1 |2 |2 Low
|I.1| Intercept control component messages |0.5 |4 |2 Low
|I.2| Modify the application code to get votes |1 |4 |4 Moderate
|I.3| Get sensitive data from health metrics |1 |1 |1 Low
|I.4| Store ballots for future decryption |1 |3 |3 Low
|I.5| Retrieve the cryptographic assets |0.5 |4 |2 Low
|D.1| Flood health metrics |1 |2 |2 Low
|D.2| Flood message broker |1 |3 |3 Low
|D.3| Place the control components in a discrepancy state |1 |3 |3 Low
|D.4| Tamper with data in the SAN |1 |3 |3 Low
|E.1| Abuse the physical access control |0.5 |4 |2 Low
|E.2| Use a software vulnerability |0.5 |4 |2 Low
|===============================================
